JUCE: juce::dsp::FirstOrderTPTFilter< SampleType > Class Template Reference

JUCE

- Main Page
- Related Pages
- Topics
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Loading...
Searching...
No Matches
Public Types | Public Member Functions | List of all members
juce::dsp::FirstOrderTPTFilter< SampleType > Class Template Reference
juce_dsp » processors

A first order filter class using the TPT (Topology-Preserving Transform) structure. More...

`#include <juce_FirstOrderTPTFilter.h>`

## Public Types
using | Type = FirstOrderTPTFilterType

## Public Member Functions
| FirstOrderTPTFilter ()
| Constructor.
void | setType (Type newType)
| Sets the filter type.
void | setCutoffFrequency (SampleType newFrequencyHz)
| Sets the cutoff frequency of the filter.
Type | getType () const noexcept
| Returns the type of the filter.
SampleType | getCutoffFrequency () const noexcept
| Returns the cutoff frequency of the filter.
void | prepare (const ProcessSpec &spec)
| Initialises the filter.
void | reset ()
| Resets the internal state variables of the filter.
void | reset (SampleType newValue)
| Resets the internal state variables of the filter to a given value.
template<typename ProcessContext >
void | process (const ProcessContext &context) noexcept
| Processes the input and output samples supplied in the processing context.
SampleType | processSample (int channel, SampleType inputValue)
| Processes one sample at a time on a given channel.
void | snapToZero () noexcept
| Ensure that the state variables are rounded to zero if the state variables are denormals.

## Detailed Description

template<typename SampleType>
class juce::dsp::FirstOrderTPTFilter< SampleType >

A first order filter class using the TPT (Topology-Preserving Transform) structure.

This filter can be modulated at high rates without producing audio artefacts. See Vadim Zavalishin's documentation about TPT structures for more information.

Note: Using this class prevents some loud audio artefacts commonly encountered when changing the cutoff frequency using of other filter simulation structures and IIR filter classes. However, this class may still require additional smoothing for cutoff frequency changes.

see StateVariableFilter, IIRFilter, SmoothedValue

## Member Typedef Documentation

## ◆ Type

template<typename SampleType >

using juce::dsp::FirstOrderTPTFilter< SampleType >::Type = FirstOrderTPTFilterType

## Constructor & Destructor Documentation

## ◆ FirstOrderTPTFilter()

template<typename SampleType >

juce::dsp::FirstOrderTPTFilter< SampleType >::FirstOrderTPTFilter | ( |  | ) |

Constructor.

## Member Function Documentation

## ◆ setType()

template<typename SampleType >

void juce::dsp::FirstOrderTPTFilter< SampleType >::setType | ( | Type | newType | ) |

Sets the filter type.

## ◆ setCutoffFrequency()

template<typename SampleType >

void juce::dsp::FirstOrderTPTFilter< SampleType >::setCutoffFrequency | ( | SampleType | newFrequencyHz | ) |

Sets the cutoff frequency of the filter.

Parameters

  newFrequencyHz | cutoff frequency in Hz.

## ◆ getType()

template<typename SampleType >

Type juce::dsp::FirstOrderTPTFilter< SampleType >::getType | ( |  | ) | const
| noexcept

Returns the type of the filter.

## ◆ getCutoffFrequency()

template<typename SampleType >

SampleType juce::dsp::FirstOrderTPTFilter< SampleType >::getCutoffFrequency | ( |  | ) | const
| noexcept

Returns the cutoff frequency of the filter.

## ◆ prepare()

template<typename SampleType >

void juce::dsp::FirstOrderTPTFilter< SampleType >::prepare | ( | const ProcessSpec & | spec | ) |

Initialises the filter.

## ◆ reset() [1/2]

template<typename SampleType >

void juce::dsp::FirstOrderTPTFilter< SampleType >::reset | ( |  | ) |

Resets the internal state variables of the filter.

## ◆ reset() [2/2]

template<typename SampleType >

void juce::dsp::FirstOrderTPTFilter< SampleType >::reset | ( | SampleType | newValue | ) |

Resets the internal state variables of the filter to a given value.

## ◆ process()

template<typename SampleType >
template<typename ProcessContext >

void juce::dsp::FirstOrderTPTFilter< SampleType >::process | ( | const ProcessContext & | context | ) |
| noexcept

Processes the input and output samples supplied in the processing context.

References jassert, juce::dsp::FirstOrderTPTFilter< SampleType >::processSample(), and juce::dsp::FirstOrderTPTFilter< SampleType >::snapToZero().

## ◆ processSample()

template<typename SampleType >

SampleType juce::dsp::FirstOrderTPTFilter< SampleType >::processSample | ( | int | channel,
|  | SampleType | inputValue
| ) |  |

Processes one sample at a time on a given channel.

Referenced by juce::dsp::FirstOrderTPTFilter< SampleType >::process().

## ◆ snapToZero()

template<typename SampleType >

void juce::dsp::FirstOrderTPTFilter< SampleType >::snapToZero | ( |  | ) |
| noexcept

Ensure that the state variables are rounded to zero if the state variables are denormals.

This is only needed if you are doing sample by sample processing.

Referenced by juce::dsp::FirstOrderTPTFilter< SampleType >::process().

The documentation for this class was generated from the following file:

- juce_FirstOrderTPTFilter.h